#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon May 16 10:51:20 2022

@author: farid
"""

import imageio
import os
import re


def tryint(s):
    try:
        return int(s)
    except:
        return s


def alphanum_key(s):
    """ Turn a string into a list of string and number chunks.
        "z23a" -> ["z", 23, "a"]
    """
    return [tryint(c) for c in re.split('([0-9]+)', s)]


def sort_nicely(input_list):
    """ Sort the given list in the way that humans expect.
    """
    input_list.sort(key=alphanum_key)


path = '../adaptivePlots'
file_ext = 'pdf'


filenames = []
for file in os.listdir(path):
    if file.endswith(f'.{file_ext}'):
        filenames.append(os.path.join(path, file))
sort_nicely(filenames)

images = []
for filename in filenames:
    images.append(imageio.imread(filename))
imageio.mimsave(f'{path}/movie.gif', images)
